// Code pour utiliser le module ultrason et envoyer la distance mesurée en MQTT
//=> tuto MQTT : https://randomnerdtutorials.com/esp32-mqtt-publish-subscribe-arduino-ide/

// Déclaration des librairies 

#include <WiFi.h>
#include <PubSubClient.h>   

// defines pins numbers
const int photores = 35;

// Pour la connexion wifi  
    const char* ssid     = "<your-wifi-name>";
    const char* password = "<your-wifi-password>";

    WiFiServer server(80);    

// Pour le serveur MQTT 
    // MQTT Broker IP address, example of my raspberry py
    const char* mqtt_server = "<ip-server-mqtt>";   

    WiFiClient espClient;
    PubSubClient client(espClient);
    long lastMsg = 0;
    char msg[50];
    int value = 0;

void setup_wifi(){
    // Initialisation wifi   
       Serial.begin(9600);
//       Serial.begin(115200);
       delay(10); 
       Serial.print("Connecting to ");
       Serial.println(ssid);
       WiFi.begin(ssid,password); 
            
       while (WiFi.status() != WL_CONNECTED) {  
         delay(500);
         Serial.print(".");
       }
            
    // Print local IP address and start web server
       Serial.println("");
       Serial.println("WiFi connected.");;
       //server.begin(); // démare le serveur 
       //Serial.print("Server started. Open a web browser with the ip address  ");
       Serial.println("IP address: ");
       Serial.println(WiFi.localIP());
       Serial.println("");
}

int photoresistance(int photores){
  int val_photores;
  val_photores = analogRead(photores);
  delay(1000);              
  return val_photores;
  
  }

void callback(char* topic, byte* message, unsigned int length) {  
      Serial.print("Message arrived on topic: ");
      Serial.print(topic);
      Serial.print(". Message: ");
      String messageTemp;
      
      for (int i = 0; i < length; i++) {
        Serial.print((char)message[i]);
        messageTemp += (char)message[i];
      }
      Serial.println();
    
      // Feel free to add more if statements to control more GPIOs with MQTT
    
      // If a message is received on the topic esp32/LEDoutput, you check if the message is either "on" or "off". 
      // Changes the output state according to the message
      /*if (String(topic) == "watertank/led") {
        Serial.print("Changing output to ");
        if(messageTemp == "on"){
          Serial.println("on");
          digitalWrite(ledPin, HIGH);
        }
        else if(messageTemp == "off"){
          Serial.println("off");
          digitalWrite(ledPin, LOW);
        }
      }
      */
}

void reconnect() {   
    // Loop until we're reconnected
    while (!client.connected()) {
      Serial.print("Attempting MQTT connection...");
      // Attempt to connect
      if (client.connect("ESP32Client")) {
        Serial.println("connected");
        // Subscribe
        client.subscribe("shutters/esp32");
      } else {
        Serial.print("failed, rc=");
        Serial.print(client.state());
        Serial.println(" try again in 5 seconds");
        // Wait 5 seconds before retrying
        delay(5000);
      }
    }
}

void setup() {

      setup_wifi();
      // Server MQTT
      client.setServer(mqtt_server, 1883);
      client.setCallback(callback);

}

void loop() {
      Serial.println(WiFi.localIP());
      Serial.println(analogRead(photores));
      
      if (!client.connected()) {
        reconnect();
      }
      client.loop();  
    
      long now = millis();
      if (now - lastMsg > 5000) {
        lastMsg = now;  
      }

          String photoval = String(photoresistance(photores));
          
          client.publish("shutters/photoval", (char*) photoval.c_str() );
          delay (1000);

      Serial.println(photoval);
}
