#include <HX711_ADC.h> // Allows to work with the weight sensor, which is a constraint jauge
#include "soc/rtc.h"
#include <WiFi.h>  // to use wifi with the esp32
#include <PubSubClient.h>   // To communiicate with MQTT 

HX711_ADC LoadCell(25, 26); // Definition of the two digital pins used, pin 25 for DT and 26 for SCK

// For wifi 
    const char* ssid     = "<your-wifi-name>";
    const char* password = "<your-wifi-password>";

    WiFiServer server(80);    // We create the http servor instance
    String header; // Variable to store the HTTP request

// MQTT 
    // MQTT Broker IP address, example of my raspberry py
    const char* mqtt_server = "<ip-server-mqtt>";   // complete adress: 192.168.0.7:1883
    

    WiFiClient espClient;
    PubSubClient client(espClient);
    long lastMsg = 0;
    char msg[50];
    int value = 0;

void setup_wifi(){
    // Initialisation of the wifi   
       Serial.begin(115200); 
       delay(10); 
       Serial.print("Connecting to ");
       Serial.println(ssid);
       WiFi.begin(ssid,password); // wifi connextion 
            
       while (WiFi.status() != WL_CONNECTED) {  
         delay(500);
         Serial.print(".");
       }
            
    // Print local IP address and start web server
       Serial.println("");
       Serial.println("WiFi connected.");;
       //server.begin(); // start the serveur 
       //Serial.print("Server started. Open a web browser with the ip address  ");
       Serial.println("IP address: ");
       Serial.println(WiFi.localIP());
       Serial.println("");
}
void callback(char* topic, byte* message, unsigned int length) {    //MQTT connection
      Serial.print("Message arrived on topic: ");
      Serial.print(topic);
      Serial.print(". Message: ");
      String messageTemp;
      
      for (int i = 0; i < length; i++) {
        Serial.print((char)message[i]);
        messageTemp += (char)message[i];
      }
      Serial.println();    
}



void reconnect() {    //  communication MQTT
    // Loop until we're reconnected
    while (!client.connected()) {
      Serial.print("Attempting MQTT connection...");
      // Attempt to connect
      if (client.connect("ESP32Client")) {
        Serial.println("connected");
        // Subscribe
        client.subscribe("Loadcell/Dog");
      } else {
        Serial.print("failed, rc=");
        Serial.print(client.state());
        Serial.println(" try again in 5 seconds");
        // Wait 5 seconds before retrying
        delay(5000);
      }
    }
}

float weightmeasure ( float weightmeasured) {
  //Serial.begin(9600);
    LoadCell.update(); // retrieves data from the load cell
  float weight = LoadCell.getData(); // get output value
  Serial.print("The mass is :");
 Serial.println(weight);
  return weight;
}
void setup() {
  rtc_clk_cpu_freq_set(RTC_CPU_FREQ_80M);  // Allows to synchornise the clock of the esp32 with the hx711 module, esp32 works too fast
  LoadCell.begin(); // start connection to HX711
  LoadCell.start(2000); // load cells gets 2000ms of time to stabilize
  LoadCell.setCalFactor(90.0); // calibration factor for load cell => strongly dependent on your individual setup
  setup_wifi();
      // Serveur MQTT
  client.setServer(mqtt_server, 1883);
  client.setCallback(callback);
  
}

void loop() {
   Serial.println(WiFi.localIP());
      if (!client.connected()) {
        reconnect();
      }
      client.loop(); 
    
      long now = millis();
      if (now - lastMsg > 5000) {
        lastMsg = now;  
      }
  float weight = weightmeasure (weight);             
  String weightstring = String(weight);
  client.publish("Loadcell/DogManager", (char*)weightstring.c_str() );
  delay (1000);
  
}
