import paho.mqtt.client as mqtt # import the client1
import paho.mqtt.publish as publish

import time
import sys
import os
import threading

#--------- functions ---------
def writeFileSingleData(fileName,data):#write a single information inside a .txt file
	file = open(fileName,"w")
	file.write(data)
	file.close()

def writeFile2DTab(fileName,tab):#receive 1D table and write 2D table inside a .txt file using ';' separator between 2 column
	temptab = readFile2DTab(fileName)#test for 2D print
	file = open(fileName,"w")
	i=0
	while i<(len(temptab)-1):
		file.write(str(temptab[i])+';'+str(tab[i/2])+'\n')
		i+=2
	file.close()

def nbrLigneFile(fileName):#Count the number of lines inside a file
	file = open(fileName,"r")
	NumberOfLine = 0
	for line in file:
		NumberOfLine += 1
	file.close()
	return NumberOfLine

def readFileSingleData(fileName):#read the contend of a .txt file containing a signe information and return this value
	file = open(fileName,"r")
	txt = file.readlines()
	file.close()
	return txt

def readFile2DTab(fileName):#read the contend of a .txt file and return a table
	file = open(fileName,"r")
	txt = file.readlines()
	i=0
	tab = []
	for line in txt:
		tab += txt[i].rstrip('\r\n').split(';')
		#print tab
		i +=1
	file.close()
	return tab

def printit():#This function check every XX seconds if data must be send to ESP32
  threading.Timer(2.0, printit).start()

  #writing mqtt

  global previous_command_tab
  pub_topic_stateToESP = "heating/stateToESP"	#Name of the topic
  actual_tab=readFile2DTab("../WEB_Programming/data/heating/command.txt")	#Copy the contend of the file
  if previous_command_tab != actual_tab : #Check if the contend has changed
  	print("command file has changed")
  	previous_command_tab = actual_tab
  	stateToESP_message=str(5)+str(actual_tab[1]) + str(actual_tab[3] + str(actual_tab[5]))#create the message
  	client.publish(pub_topic_stateToESP, stateToESP_message)#send the message

  global previous_setpoint_tab
  pub_topic_setpoint = "heating/parameters"	#Where the command is sent
  actual_tab=readFile2DTab("../WEB_Programming/data/heating/setpoint.txt")	#Copy the contend of the file
  if previous_setpoint_tab != actual_tab : #Check if the contend has changed
  	print("setpoint file has changed")
  	previous_setpoint_tab = actual_tab
  	setpoint_message=str(7)+str(actual_tab[1]) + str(actual_tab[3] + str(actual_tab[5])+ str(actual_tab[7])+ str(actual_tab[9]))#create the message
  	client.publish(pub_topic_setpoint, setpoint_message)

#--------- Callbacks - When a PUBLISH message is received from the server ------

def on_message_temperature(client, userdata, message):
    temperature = str(message.payload.decode("utf-8"))
    print(message.topic+" "+temperature)
    writeFileSingleData("../WEB_Programming/data/heating/temperature.txt",temperature)

def on_message_humidity(client, userdata, message):
    humidity = str(message.payload.decode("utf-8"))
    print(message.topic+" "+humidity)
    writeFileSingleData("../WEB_Programming/data/heating/humidity.txt",humidity)

def on_message_stateToPi(client, userdata, message):
	stateToPi = str(message.payload.decode("utf-8"))
	print(message.topic+" "+stateToPi)
	stateToPi2 = list(stateToPi[0]) + list(stateToPi[1]) + list(stateToPi[2]) + list(stateToPi[3])
	writeFile2DTab("../WEB_Programming/data/heating/stateToPi.txt",stateToPi2)

def on_message_setpointToPi(client, userdata, message):
	setpointToPi = str(message.payload.decode("utf-8"))
	print(message.topic+" "+setpointToPi)
	setpointToPi2 = [(setpointToPi[0]+setpointToPi[1]+setpointToPi[2]+setpointToPi[3]+setpointToPi[4]) ,(setpointToPi[5]+setpointToPi[6]+setpointToPi[7]+setpointToPi[8]+setpointToPi[9]) ,(setpointToPi[10]+setpointToPi[11]+setpointToPi[12]+setpointToPi[13]) ,(setpointToPi[14]+setpointToPi[15]+setpointToPi[16]+setpointToPi[17]) ,(setpointToPi[18]+setpointToPi[19]+setpointToPi[20]+setpointToPi[21])]
	writeFile2DTab("../WEB_Programming/data/heating/setpointToPi.txt",setpointToPi2)

def on_message(client, userdata, message):
    print(message.topic+" "+str(message.qos)+" "+str(message.payload))

def on_disconnect(client, userdata,rc=0):
    logging.debug("DisConnected result code "+str(rc))
    client.loop_stop()

#--------- main ---------
broker_address="<ip-server-mqtt>"
client = mqtt.Client("P42") #create new mqtt instance
print("connecting to broker")
client.connect(broker_address) #connect to the mqtt broker

previous_command_tab=readFile2DTab("../WEB_Programming/data/heating/command.txt")
previous_setpoint_tab=readFile2DTab("../WEB_Programming/data/heating/setpoint.txt")

printit()

client.loop_start() #start the loop

#reading mqtt
client.subscribe("heating/#")
client.message_callback_add('heating/temperature',on_message_temperature)
client.message_callback_add('heating/humidity',on_message_humidity)
client.message_callback_add('heating/stateToPi',on_message_stateToPi)
client.message_callback_add('heating/setpointToPi',on_message_setpointToPi)
client.on_message = on_message #attach function to callback
