#!/usr/bin/env /usr/bin/python
# coding=utf-8
import paho.mqtt.client as mqtt #import the client1
import paho.mqtt.publish as publish

#!/usr/bin/python
# -*- coding: utf-8 -*-
#
# RPi-S-LCD.py
# Created on 21/1/2017
#

import time
import sys
import os
# import threading

############ Parameters ###############

pub_topic_light_command = "ESP32/LightOutput/"	#Topic name where the command is sent
Light_output_path = "../WEB_Programming/data/light/light_output.txt" #Where the .txt file is stocked
broker_address="<ip-server-mqtt>" #ip address of the broker (localhost)

############ Functions ###############

#When MQTT client recieve a message, program has to write it in a .txt ans active output
def writeFile(nameFile,variable):
	file = open(nameFile,"w")
	file.write(variable)
	file.close()

def nbLineFile(nameFile):
	file = open(nameFile, "r")
	temps_text  = file.readlines()	#save text in variable "temp_text" enregistre les lignes dans texte
	nb_line = 0
	for line in temps_text:
		nb_line += 1
	file.close()
	return nb_line


def readFile(nameFile):
	file = open(nameFile,"r")
	texte  = file.readlines()	#enregistre les lignes dans texte
	text= ''.join(texte)	#convert list into strings
	file.close()
	i=0
	for ligne in text:	#lire ligne par ligne
		tab = [text.split(";"), i]	#tableau 2D
		i +=1
	return tab

def readFile2DTab(fileName):#read the contend of a .txt file and return a table
	file = open(fileName,"r")
	txt = file.readlines()
	i=0
	tab = []
	for line in txt:
		tab += txt[i].rstrip('\r\n').split(';')
		i += 1
	file.close()
	return tab



#--------- The callback for when a PUBLISH message is received from the server.------

#--------- To manage event on MQTT -----
def ContinuousLoop():#This function check every XX seconds if data must be send to ESP32
	# threading.Timer(2.0, ContinuousLoop).start()
	##Publish part to activate gpio pin on ESP32
	actual_tab=readFile2DTab(Light_output_path)

	global previous_tab
	# print("test in printit")
  	if previous_tab != actual_tab : #send a new message only if the file has changed
		print("tab has changed")
		previous_tab = actual_tab
		j=0
		for i in range(nbLineFile(Light_output_path)):
			message=str(actual_tab[1+j]) + "/" + str(actual_tab[2+j]) + "/" + str(actual_tab[3+j])
		  	pub_topic = pub_topic_light_command + str(actual_tab[0+j])
		  	client.publish(pub_topic, message)#publish
		  	j+=4 # to jump to the next line
		  	print("message sent to topic : " + pub_topic + " => " + message)
		  	time.sleep(.500) #wait 500ms


def on_message_esp32(client, userdata, message):
    text = str(message.payload.decode("utf-8"))
    print(text)
    # writeFile("data/watertank/watertank_temperature.txt",temperature)

def on_message(client, userdata, message):
    print(message.topic+" "+str(message.qos)+" "+str(message.payload))

#function which permits stopping to get the values when the mqtt client is disconnected
def on_disconnect(client, userdata,rc=0):
    logging.debug("DisConnected result code "+str(rc))
    client.loop_stop()


############ Loop code ###############


client = mqtt.Client("P1") #create new instance
print("connecting to broker")
client.connect(broker_address) #connect to broker

client.loop_start() #start the loop
print("Connected. Starting...")
time.sleep(4)


client.subscribe("ESP32/LightOutput/response")
client.message_callback_add('ESP32/LightOutput/response',on_message_esp32)
client.on_message=on_message #attach function to callback

previous_tab= []
# previous_tab=readFile2DTab(Light_output_path)
while True :
	ContinuousLoop()
	time.sleep(1)
