import paho.mqtt.client as mqtt #import the client1
import paho.mqtt.publish as publish

#!/usr/bin/python
# -*- coding: utf-8 -*-
#
# RPi-S-LCD.py
# Created on 21/1/2017
#
# Python program that use LCD 20x4 to display topics info
#

import time
import sys
import os
############

#function which permits to write the variables into the indicated file
def writeFile(nameFile,variable):
	file = open(nameFile,"w")
	file.write(variable)
	file.close()

#function which permits writing the temperature value into the temperature file
def on_message_temperature(client, userdata, message):
    temperature = str(message.payload.decode("utf-8"))
    print(temperature)
    writeFile("../WEB_Programming/data/outside_station/outside_station_temperature.txt",temperature)

#function which permits writing the humidity value into the humidity file
def on_message_humidity(client, userdata, message):
    humidity = str(message.payload.decode("utf-8"))
    print(humidity)
    writeFile("../WEB_Programming/data/outside_station/outside_station_humidity.txt",humidity)

#function which permits writing the distance of the water level value into the distance file
def on_message_distance(client, userdata, message):
    distance = str(message.payload.decode("utf-8"))
    print(distance)
    writeFile("../WEB_Programming/data/outside_station/outside_station_distance.txt",distance)


def on_message(client, userdata, message):
    print(message.topic+" "+str(message.qos)+" "+str(message.payload))

#function which permits stopping to get the values when the mqtt client is disconnected
def on_disconnect(client, userdata,rc=0):
    logging.debug("DisConnected result code "+str(rc))
    client.loop_stop()

#######################################
broker_address="<ip-server-mqtt>" #broker adress
client = mqtt.Client("P1") #create new instance
print("connecting to broker")
client.connect(broker_address) #connect to broker

client.loop_start() #start to read mqtt value
client.subscribe("outside_station/#") #subscribe to the desired topic
client.message_callback_add('outside_station/temperature',on_message_temperature) #get the value of the desired topic
client.message_callback_add('outside_station/humidity',on_message_humidity) #get the value of the desired topic
client.message_callback_add('outside_station/distance',on_message_distance) #get the value of the desired topic
client.on_message=on_message #attach function to callback



time.sleep(1000); #the program sleep during 1000 ms
